import { Component } from "@angular/core";
import { Router } from "@angular/router";
import { MegaMenuItem, MenuItem } from "primeng/api";
import { Subscription } from "rxjs";
import { LoginService } from "./common/service/login.service";
import { UsuarioDTO } from "./common/dto/usuarioDTO";

@Component({
  selector: "app-root",
  templateUrl: "./app.component.html"
})
export class AppComponent {
  title = "bitfrontlibrary";
  items: MegaMenuItem[];
  usuario: UsuarioDTO;

  private subscriptionLogin: Subscription;

  constructor(public loginService: LoginService, public router: Router) {
    this.usuario = new UsuarioDTO(1, "developer", "devop");
  }

  ngOnInit() {
    this.items = [
      {
        label: "Ejemplos PrimeNG Form",
        items: [[{ items: [{ label: "Form components", icon: "fa fa-users", routerLink: ["form"] }] }]]
      },
      {
        label: "Ejemplos CRUD",
        items: [
          [
            { items: [{ label: "crud-ngrx7", icon: "fa fa-users", routerLink: ["crud-ngrx7"] }] },
            { items: [{ label: "crud-ngrx8", icon: "fa fa-users", routerLink: ["crud-ngrx8"] }] },
            { items: [{ label: "crud-ngrxdata", icon: "fa fa-users", routerLink: ["crud-ngrxdata"] }] }
          ]
        ]
      },
      {
        label: "Developer",
        items: [
          [
            { items: [{ label: "Logs", icon: "fa fa-bars", routerLink: ["developer/logs"] }] },
            {
              items: [{ label: "Excepcions", icon: "fa fa-exclamation-triangle", routerLink: ["developer/exceptions"] }]
            },
            { items: [{ label: "Consultes a B. DD.", icon: "fa fa-pencil-square-o", routerLink: ["developer/hql"] }] },
            { items: [{ label: "Configuració", icon: "fa fa-pencil-square-o", routerLink: ["developer/config"] }] }
          ]
        ]
      }
    ];
  }
}
