import { ModuleWithProviders } from "@angular/core";
import { Routes, RouterModule, PreloadAllModules } from "@angular/router";

export const routes: Routes = [
  { path: "", redirectTo: "home", pathMatch: "full" },
  { path: "form", loadChildren: () => import("./test/form/form.module").then((m) => m.FormModule) },
  { path: "developer", loadChildren: () => import("./developer/developer.module").then((m) => m.DeveloperModule) },
  { path: "crud-ngrx7", loadChildren: () => import("./test/crud_v1/crud-v1.module").then((m) => m.CrudV1Module) },
  { path: "crud-ngrx8", loadChildren: () => import("./test/crud_v2/crud-v2.module").then((m) => m.CrudV2Module) },
  { path: "crud-ngrxdata", loadChildren: () => import("./test/crud_v3/crud-v3.module").then((m) => m.CrudV3Module) }
];

export const routing: ModuleWithProviders<RouterModule> = RouterModule.forRoot(routes, {
    preloadingStrategy: PreloadAllModules,
    relativeLinkResolution: 'legacy'
});
