import { Subject } from "rxjs";
import { Store } from "@ngrx/store";
import { Directive } from "@angular/core";

@Directive()
export class BaseComponent<V> {
  destroy$: Subject<boolean> = new Subject<boolean>();

  constructor(protected store: Store<V>) {}

  ngOnDestroy() {
    this.destroy$.next(true);
    this.destroy$.unsubscribe();
  }
}
