import { NgModule, Optional, SkipSelf } from "@angular/core";
import { HTTP_INTERCEPTORS } from "@angular/common/http";

import { environment } from "../../environments/environment";
import { LoginService } from "./service/login.service";
import { ConfiguracionService } from "../developerlibrary/shared/service/configuracion.service";
import { SharedModule } from "../shared/shared.module";
import { CanDeactivateGuard } from "../shared/guard/candeactivate.guard";
import { CustomHttpInterceptor } from "../shared/utils/custom-http-interceptor";
import * as fromServices from "../shared/service";

@NgModule({
  imports: [SharedModule],
  providers: [
    { provide: "API_URL", useValue: environment.API_URL }, // Se provee API_URL para que la utilize HttpUtilsService, UploadService, etc
    { provide: "DOWNLOAD_URL", useValue: environment.DOWNLOAD_URL },
    { provide: "CONTEXT_PATH", useValue: environment.CONTEXT },
    { provide: HTTP_INTERCEPTORS, useClass: CustomHttpInterceptor, multi: true },
    ...fromServices.services,
    LoginService,
    ConfiguracionService,
    CanDeactivateGuard
  ]
  //exports: [SharedModule]
})
export class CommonModule {
  constructor(@Optional() @SkipSelf() parentModule: CommonModule) {
    if (parentModule) {
      throw new Error("CommonModule is already loaded. Import it in the AppModule only");
    }
  }
}
