import { Component, Input } from "@angular/core";
import { Router, ActivatedRoute } from "@angular/router";

import { Item } from "../../shared/data/item";
import { BaseTableViewComponent } from "../../base/index";
import { DomainCachedService, TableViewService } from "../../shared/index";

@Component({
  selector: "config-list-tableview",
  template: `
    <!--<p-dataTable [value]="items" (onRowClick)="gotoForm($event)" selectionMode="single" *ngIf="(items != null && items.length > 0)">
  <p-column field="codigo" header="Codi" [sortable]="true"></p-column>
  <p-column field="valor" header="Valor" [sortable]="true"></p-column>
</p-dataTable>-->
    <p-table
      [columns]="cols"
      [value]="items"
      (onRowClick)="gotoForm($event)"
      selectionMode="single"
      *ngIf="items != null && items.length > 0"
    >
      <ng-template pTemplate="header">
        <tr>
          <th pSortableColumn="codigo">Codi<p-sortIcon field="codigo"></p-sortIcon></th>
          <th pSortableColumn="valor">Valor<p-sortIcon field="valor"></p-sortIcon></th>
        </tr>
      </ng-template>
      <ng-template pTemplate="body" let-rowData>
        <tr (click)="gotoForm(rowData)">
          <td>{{ rowData.codigo }}</td>
          <td>{{ rowData.valor }}</td>
        </tr>
      </ng-template>
    </p-table>
  `
})
export class ConfigListTableViewComponent extends BaseTableViewComponent {
  @Input() items: Item[];

  cols: any[] = [
    { field: "codigo", header: "Codi" },
    { field: "valor", header: "Valor" }
  ];

  constructor(
    protected domainCachedService: DomainCachedService,
    protected tableViewService: TableViewService,
    private router: Router,
    protected activatedRoute: ActivatedRoute
  ) {
    super(domainCachedService, tableViewService);
    this.cols = [
      { field: "codigo", header: "Codi" },
      { field: "valor", header: "Valor" }
    ];
  }

  gotoForm(event) {
    this.router.navigate(["form", event.codigo], { relativeTo: this.activatedRoute }); //, {relativeTo: this.activatedRoute}
  }
}
