import { Component, Input } from "@angular/core";
import { MessageService } from "../../shared/service/message.service";
import { Item } from "../../shared/data/item";
import { BitMessage } from "../../shared/data/bitmessage";

@Component({
  selector: "exception-list-tableview",
  template: `
    <!--<p-dataTable [value]="items" *ngIf="(items != null && items.length > 0)">
  <p-column field="login" header="Login" [sortable]="true"></p-column>
  <p-column field="concepto" header="Concepto" [sortable]="true"></p-column>
  <p-column field="method" header="Operación" [sortable]="true"></p-column>
  <p-column field="fecha" header="Hora" [sortable]="true">
      <ng-template let-log="rowData" pTemplate type="body">
          <span>{{log.fecha | date:"HH:mm"}}</span>
      </ng-template>
  </p-column> 
  <p-column styleClass="col-button">
      <ng-template let-log="rowData" pTemplate type="body">            
          <div class="btn-group" role="group">
              <button *ngIf="log.error" class="btn btn-danger btn-xs" (click)="showDatosLog($event,log.error,'Error');"> Error&nbsp;&nbsp;<span class="glyphicon glyphicon-alert"></span>
              </button>
          </div>
      </ng-template>
  </p-column>
</p-dataTable>-->
    <p-table [columns]="cols" [value]="items" *ngIf="items != null && items.length > 0">
      <ng-template pTemplate="header">
        <tr>
          <th pSortableColumn="login">Login<p-sortIcon field="login"></p-sortIcon></th>
          <th pSortableColumn="concepto">Concepto<p-sortIcon field="concepto"></p-sortIcon></th>
          <th pSortableColumn="method">Operación<p-sortIcon field="method"></p-sortIcon></th>
          <th pSortableColumn="fecha">Hora<p-sortIcon field="fecha"></p-sortIcon></th>
          <th></th>
        </tr>
      </ng-template>
      <ng-template pTemplate="body" let-log>
        <tr (click)="gotoForm(log)">
          <td>{{ log.login }}</td>
          <td>{{ log.concepto }}</td>
          <td>{{ log.method }}</td>
          <td>
            <span>{{ log.fecha | date: "HH:mm" }}</span>
          </td>
          <td class="col-button">
            <div class="btn-group" role="group">
              <button
                *ngIf="log.error"
                class="btn btn-danger btn-xs"
                (click)="showDatosLog($event, log.error, 'Error')"
              >
                Error&nbsp;&nbsp;<span class="glyphicon glyphicon-alert"></span>
              </button>
            </div>
          </td>
        </tr>
      </ng-template>
    </p-table>
    <!-- cols = [
{ field: "login", header: "Login" },
{ field: "concepto", header: "Concepto" },
{ field: "method", header: "Operación" },
{ field: "fecha", header: "Hora" },
{ field: "", header: "" },
]; -->
  `
})
export class ExceptionListTableViewComponent {
  @Input()
  items: Item[];
  cols = [
    { field: "login", header: "Login" },
    { field: "concepto", header: "Concepto" },
    { field: "method", header: "Operación" },
    { field: "fecha", header: "Hora" },
    { field: "", header: "" }
  ];

  constructor(private messageService: MessageService) {}

  /** Muestra los datos de log en un diálogo*/
  showDatosLog(event, log: string, titulo: string) {
    let width: number = BitMessage.WIDTH;
    if (titulo === "Error") {
      width = 800;
    }
    this.messageService.sendMessage(new BitMessage(titulo, log, width));
  }

  gotoForm() {
    console.log("go");
  }
}
