import { Component, Input } from "@angular/core";
import { MessageService } from "../../shared/service/message.service";
import { Item } from "../../shared/data/item";
import { BitMessage } from "../../shared/data/bitmessage";

@Component({
  selector: "log-list-tableview",
  templateUrl: "./log-list-tableview.component.html"
})
export class LogListTableViewComponent {
  @Input() items: Item[];
  cols = [
    { field: "login", header: "Login" },
    { field: "concepto", header: "Concepto" },
    { field: "tipo", header: "Operación" },
    { field: "fecha", header: "Hora" },
    { field: "", header: "" }
  ];

  constructor(private messageService: MessageService) {}

  /** Muestra los datos de log en un diálogo*/
  showDatosLog(event, log: string, titulo: string) {
    let width: number = BitMessage.WIDTH;
    let json: boolean = true;
    if (titulo === "Error") {
      width = 800;
      json = false;
    }
    let bitMessage: BitMessage = new BitMessage(titulo, log, width);
    bitMessage.json = json;
    this.messageService.sendMessage(bitMessage);
  }

  gotoForm() {
    console.log("go");
  }
}
