export class ConfigurationEditor {
  constructor(
    public fontFamily: boolean = true,
    public fontSize: boolean = true,
    public fontFormat: boolean = true,
    public color: boolean = true,
    public background: boolean = true,
    public script: boolean = false,
    public header: boolean = true,
    public blockquote: boolean = true,
    public codeBlock: boolean = true,
    public bullet: boolean = true,
    public indent: boolean = true,
    public direction: boolean = false,
    public align: boolean = true,
    public link: boolean = true,
    public image: boolean = true,
    public video: boolean = false,
    public clean: boolean = true
  ) {}

  public static newObject(): ConfigurationEditor {
    return new ConfigurationEditor();
  }

  public static newObjectWithAllControls() {
    return new ConfigurationEditor(
      true,
      true,
      true,
      true,
      true,
      true,
      true,
      true,
      true,
      true,
      true,
      true,
      true,
      true,
      true,
      true,
      true
    );
  }

  // Se indican en el objeto pasado por parámetro solo los controles que aparecerán en el editor
  public static newCustomObject(object: any): ConfigurationEditor {
    let editor = new ConfigurationEditor();

    Object.keys(editor).forEach((k) => (editor[k] = false));
    Object.assign(editor, object);

    return editor;
  }
}
