import { NgModule } from "@angular/core";
import { ReactiveFormsModule, FormsModule } from "@angular/forms";
import { CommonModule } from "@angular/common";
import { HttpClientModule } from "@angular/common/http";

import { FocusRegisterDirective } from "./directive/focus-register.directive";

import * as fromComponents from "./component";
import * as fromPipes from "./pipe";

//import { SharedModule as primeSharedModule } from "primeng/shared";
import { CalendarModule } from "primeng/calendar";
import { DropdownModule } from "primeng/dropdown";
import { EditorModule } from "primeng/editor";
import { MultiSelectModule } from "primeng/multiselect";
import { PaginatorModule } from "primeng/paginator";
import { CheckboxModule } from "primeng/checkbox";
import { RadioButtonModule } from "primeng/radiobutton";
import { TabViewModule } from "primeng/tabview";
import { DialogModule } from "primeng/dialog";
import { AccordionModule } from "primeng/accordion";
import { AutoCompleteModule } from "primeng/autocomplete";
import { InputSwitchModule } from "primeng/inputswitch";
import { TooltipModule } from "primeng/tooltip";
import { OverlayPanelModule } from "primeng/overlaypanel";
import { MessagesModule } from "primeng/messages";
import { MessageService } from "primeng/api";
import { MenuModule } from "primeng/menu";
import { MenubarModule } from "primeng/menubar";
import { MegaMenuModule } from "primeng/megamenu";
//import { GrowlModule } from "primeng/growl";
import { TableModule } from "primeng/table";
import { ToastModule } from "primeng/toast";
import { FileUploadModule } from "ng2-file-upload";

const modules: any[] = [
  CommonModule,
  ReactiveFormsModule,
  FormsModule,
  HttpClientModule,
  CalendarModule,
  DropdownModule,
  EditorModule,
  MultiSelectModule,
  PaginatorModule,
  CheckboxModule,
  RadioButtonModule,
  TabViewModule,
  DialogModule,
  MenuModule,
  MegaMenuModule,
  MenubarModule,
  ToastModule,
  TableModule,
  //primeSharedModule,
  AccordionModule,
  AutoCompleteModule,
  InputSwitchModule,
  TooltipModule,
  OverlayPanelModule,
  MessagesModule
];

@NgModule({
  imports: [...modules, FileUploadModule],
  declarations: [FocusRegisterDirective, ...fromComponents.components, ...fromPipes.pipes],
  exports: [...modules, FocusRegisterDirective, ...fromPipes.pipes, ...fromComponents.components],
  providers: [MessageService]
})
export class SharedModule {}
