import { NgModule } from "@angular/core";
import { StoreModule } from "@ngrx/store";
import { EffectsModule } from "@ngrx/effects";

/* Other Modules */
import { SharedModule } from "../../shared/shared.module";

import { reducers, effects } from "./store";
import { crudV1routing } from "./crud-v1.routing";

/* Components */
import * as fromComponents from "./components";
/* Services */
import { UsuarioService } from "./shared/usuario.service";
/** Guards */
import * as fromGuards from "./guards";
import { UsuarioMockService } from "./shared/usuario-mock.service";

@NgModule({
  imports: [
    SharedModule,
    crudV1routing,
    StoreModule.forFeature("usuarios", reducers),
    EffectsModule.forFeature(effects)
  ],
  declarations: [...fromComponents.components],
  providers: [{ provide: UsuarioService, useClass: UsuarioMockService }, ...fromGuards.guards],
  exports: []
})
export class CrudV1Module {
  constructor() {
    console.log("CrudV1Module constructor");
  }
}
