import { ModuleWithProviders } from "@angular/core";
import { RouterModule } from "@angular/router";
import { CanDeactivateGuard } from "../../shared/guard/candeactivate.guard";
import { UsuarioFormV1Guard } from "./guards/usuario-form-v1.guard";
import { UsuarioListV1Component, UsuarioFormV1Component } from "./components";

export const crudV1routing: ModuleWithProviders<RouterModule> = RouterModule.forChild([
  {
    path: "",
    component: UsuarioListV1Component
  },
  {
    path: "form",
    component: UsuarioFormV1Component,
    canDeactivate: [CanDeactivateGuard],
    canActivate: [UsuarioFormV1Guard]
  },
  {
    path: "form/:id",
    component: UsuarioFormV1Component,
    canDeactivate: [CanDeactivateGuard],
    canActivate: [UsuarioFormV1Guard]
  }
]);
