import { BaseFilter } from "../../../base/shared/base.filter";

export class UsuarioFilter extends BaseFilter {
  constructor(
    public nombre: string,
    public login: string,
    public organizacionId: number,
    public campanyaId: number,
    public mostrarTodos: boolean,
    public resultados: number,
    public pagina: number
  ) {
    super(resultados, pagina);
  }

  public static newObject(): UsuarioFilter {
    let filter = new UsuarioFilter("", "", null, null, false, BaseFilter.RESULTADOS_PAGE, BaseFilter.PAGE);
    return filter;
  }

  public reset() {
    super.reset();
    this.nombre = "";
    this.login = "";
    this.campanyaId = null;
  }

  public copy() {
    return new UsuarioFilter(
      this.nombre,
      this.login,
      this.organizacionId,
      this.campanyaId,
      this.mostrarTodos,
      this.resultados,
      this.pagina
    );
  }
}
