import { ActionReducerMap, createFeatureSelector } from "@ngrx/store";
import * as fromUsuarioList from "./usuario-list.reducer";
import * as fromUsuarioForm from "./usuario-form.reducer";

export interface UsuarioState {
  usuarioForm: fromUsuarioForm.UsuarioFormState;
  usuarioList: fromUsuarioList.UsuarioListState;
}

export const reducers: ActionReducerMap<UsuarioState> = {
  usuarioForm: fromUsuarioForm.reducer,
  usuarioList: fromUsuarioList.reducer
};

export const getUsuarioState = createFeatureSelector<UsuarioState>("usuarios");
