import * as fromModels from "../../../../base/models";

import * as fromUsuarioForm from "../actions/usuario-form.action";
import { Usuario } from "../../../../common/data/usuario";

export interface UsuarioFormState extends fromModels.BaseFormState<Usuario> {}

export const adapter: fromModels.BaseFormAdapter<Usuario> = fromModels.createBaseFormAdapter(Usuario.newObject);

const initialState = adapter.getInitialState();

export function reducer(state = initialState, action: fromUsuarioForm.UsuarioFormAction): UsuarioFormState {
  switch (action.type) {
    case fromUsuarioForm.CREATE_USUARIO: {
      return adapter.handleCreateObject(state);
    }
    case fromUsuarioForm.LOAD_USUARIO: {
      return adapter.handleLoadObject(state);
    }
    case fromUsuarioForm.LOAD_USUARIO_SUCCESS: {
      return adapter.handleLoadObjectSuccess(action.payload, state);
    }
    case fromUsuarioForm.INSERT_USUARIO:
    case fromUsuarioForm.UPDATE_USUARIO: {
      return adapter.handleSaveObject(state);
    }
    case fromUsuarioForm.INSERT_USUARIO_SUCCESS:
    case fromUsuarioForm.UPDATE_USUARIO_SUCCESS: {
      return adapter.handleSaveObjectSuccess(action.payload, state);
    }
    case fromUsuarioForm.LOAD_USUARIO_FAIL:
    case fromUsuarioForm.INSERT_USUARIO_FAIL:
    case fromUsuarioForm.UPDATE_USUARIO_FAIL:
    case fromUsuarioForm.DELETE_USUARIO_FAIL: {
      return adapter.handleSaveObjectFail(state);
    }
    case fromUsuarioForm.SET_FORM_READ_ONLY: {
      return adapter.handleSetFormReadOnly(action.payload, state);
    }
  }
  return state;
}

export const {
  getItem,
  getToolbar,
  getStatus,
  getFormType,
  getCurrentTab,
  getReadOnly,
  getLoaded,
  getUpdated
} = adapter.getSelectors();
