import { Usuario } from "../../../../common/data/usuario";
import { UsuarioFilter } from "../../shared/usuario.filter";

import * as fromModels from "../../../../base/models";
import * as fromUsuarioList from "../actions/usuario-list.action";

export interface UsuarioListState extends fromModels.BaseListState<Usuario, UsuarioFilter> {}

export const adapter: fromModels.BaseListAdapter<Usuario, UsuarioFilter> = fromModels.createBaseListAdapter<
  Usuario,
  UsuarioFilter
>();

function createFilter() {
  var filter = UsuarioFilter.newObject();
  return filter;
}

export function reducer(
  state: UsuarioListState = adapter.getInitialState(createFilter, {}),
  action: fromUsuarioList.UsuarioListAction
): UsuarioListState {
  switch (action.type) {
    case fromUsuarioList.LOAD_USUARIOS: {
      return adapter.handleLoadItems(action.payload, state);
    }
    case fromUsuarioList.LOAD_USUARIOS_SUCCESS: {
      return adapter.handleLoadItemsSuccess(action.payload, state);
    }
    case fromUsuarioList.LOAD_USUARIOS_FAIL: {
      return adapter.handleLoadItemsFail(state);
    }
    case fromUsuarioList.COUNT_USUARIOS: {
      return adapter.handleCountItems(state);
    }
    case fromUsuarioList.COUNT_USUARIOS_FAIL: {
      return adapter.handleCountItemsFail(state);
    }
    case fromUsuarioList.COUNT_USUARIOS_SUCCESS: {
      return adapter.handleCountItemsSuccess(action.payload, state);
    }
    case fromUsuarioList.PAGE_CHANGE: {
      return adapter.handlePageChange(action.payload, state);
    }
    case fromUsuarioList.NEW_PAGE_SIZE: {
      return adapter.handleNewPageSizeChange(action.payload, state);
    }
    case fromUsuarioList.RESET_FILTER: {
      return adapter.handleResetFilter(action.payload, state);
    }
    case fromUsuarioList.SET_LIST_READ_ONLY: {
      return adapter.handleListReadOnly(action.payload, state);
    }
  }
  return state;
}

export const { getItems, getStatus, getFilter, getToolbar, getTotalItems } = adapter.getSelectors();
