import { Component, Input, ChangeDetectionStrategy, Output, EventEmitter } from "@angular/core";
import { BaseTableViewComponent } from "../../../../base/index";
import { DomainCachedService, Item, TableViewService } from "../../../../shared/index";

/**
 * Componente tableview de listado de usuarios.
 */
@Component({
  selector: "usuario-list-v2-tableview",
  changeDetection: ChangeDetectionStrategy.OnPush,
  templateUrl: "usuario-list-v2-tableview.component.html"
})
export class UsuarioListV2TableViewComponent extends BaseTableViewComponent {
  @Input() items: Item[];
  @Output() private onRowClick = new EventEmitter<Object>();

  cols = [
    { field: "id", header: "Id" },
    { field: "nombre", header: "Nom" },
    { field: "apellidos", header: "Cognoms" },
    { field: "login", header: "Login" },
    { field: "fechaBaja", header: "Data de baixa" }
  ];

  constructor(protected domainCachedService: DomainCachedService, protected tableViewService: TableViewService) {
    super(domainCachedService, tableViewService);
  }

  gotoForm(event) {
    this.onRowClick.emit(event);
  }
}
