import { NgModule } from "@angular/core";
import { StoreModule } from "@ngrx/store";
import { EffectsModule } from "@ngrx/effects";

/* Other Modules */
import { SharedModule } from "../../shared/shared.module";

import { reducers, effects } from "./store";
import { crudV2routing } from "./crud-v2.routing";

/* Components */
import * as fromComponents from "./components";
/* Services */
import { UsuarioService } from "./shared/usuario.service";
import { UsuarioMockService } from "./shared/usuario-mock.service";
/** Guards */
import * as fromGuards from "./guards";

@NgModule({
  imports: [
    SharedModule,
    crudV2routing,
    StoreModule.forFeature("usuariosV2", reducers),
    EffectsModule.forFeature(effects)
  ],
  declarations: [...fromComponents.components],
  providers: [{ provide: UsuarioService, useClass: UsuarioService }, ...fromGuards.guards],
  exports: []
})
export class CrudV2Module {
  constructor() {
    console.log("CrudV2Module constructor");
  }
}
