import { ModuleWithProviders } from "@angular/core";
import { RouterModule } from "@angular/router";
import { CanDeactivateGuard } from "../../shared/guard/candeactivate.guard";
import { UsuarioFormV2Guard } from "./guards/usuario-form-v2.guard";
import { UsuarioListV2Component, UsuarioFormV2Component } from "./components";

export const crudV2routing: ModuleWithProviders<RouterModule> = RouterModule.forChild([
  {
    path: "",
    component: UsuarioListV2Component
  },
  {
    path: "form",
    component: UsuarioFormV2Component,
    canDeactivate: [CanDeactivateGuard],
    canActivate: [UsuarioFormV2Guard]
  },
  {
    path: "form/:id",
    component: UsuarioFormV2Component,
    canDeactivate: [CanDeactivateGuard],
    canActivate: [UsuarioFormV2Guard]
  }
]);
