import { Injectable } from "@angular/core";
import { FormType } from "../../../shared";
import { Observable, of } from "rxjs";
import { BaseFilter } from "../../../base";
import { Usuario } from "../../../common/data/usuario";

@Injectable()
export class UsuarioMockService {
  usuario: Usuario = new Usuario(1, "esteban", "luengo simón", "eluengo", null, null);

  /** Inserta o modifica la información del elemento. */
  save(object: Usuario, mode: FormType, params?: { [key: string]: string }): Observable<Usuario> {
    console.log(`usuario almacenado para el modo ${mode}`);
    if (mode == FormType.Insert) {
      let newUsuario = new Usuario(70, "nombre 70", "apellidos 70", "usurio 70", null, null);
      newUsuario.id = 1;
      return of(newUsuario);
    } else {
      let newUsuario = new Usuario(object.id, object.nombre, object.apellidos, object.login, null, null);
      return of(newUsuario);
    }
  }

  /** Inserta o modifica la información del elemento. */
  saveObject(object: Usuario, params?: { [key: string]: string }): Observable<Usuario> {
    return this.save(object, object && object.id ? FormType.Update : FormType.Insert, params);
  }

  /** Elimina el elemento. */
  delete(id: number, params?: { [key: string]: string }): Observable<boolean> {
    console.log(`usuario con id ${id} borrado`);
    return of(true);
  }

  /** Elimina todos los elementos pasados por parámetro */
  deleteAll(items: number[], params?: { [key: string]: string }): Observable<any> {
    console.log("todos los usuarios borrados");
    return of(true);
  }

  /** Recupera la información del elemento. */
  get(id: number, params?: { [key: string]: string }): Observable<Usuario> {
    //let random: number = Math.floor(Math.random() * 20);
    let newUsuario = new Usuario(id, "nombre " + id, "apellidos " + id, "usurio " + id, null, null);
    console.log(`usuario con id ${newUsuario.id} recuperado`);
    return of(newUsuario);
  }

  /** Recupera la lista (opcionalmente, filtrada y paginada) de elementos. */
  getAllByFilter(filter: BaseFilter, params?: { [key: string]: string }): Observable<Usuario[]> {
    console.log("getAllByFilter recuperando usuarios");
    let usuarios: Usuario[] = new Array(5);
    let pagina: number = filter.pagina;
    for (let index = 0; index < 20; index++) {
      usuarios[index] = new Usuario(
        index * pagina,
        "Nombre " + index * pagina,
        "Apellidos " + index * pagina,
        "user " + index * pagina,
        null,
        null
      );
    }
    return of(usuarios);
  }

  /** Recupera el número total de la lista (filtrada) de elementos. */
  countAllByFilter(filter: BaseFilter, params?: { [key: string]: string }): Observable<number> {
    console.log("Count llamado para 60 usuarios");
    return of(60);
  }
}
