import { createAction, props } from "@ngrx/store";

import { Usuario } from "../../../../common/data/usuario";
import * as fromModels from "../../../../base/models";

export const CREATE_USUARIO = "[UsuarioV2] Create Usuario";
export const LOAD_USUARIO = "[UsuarioV2] Load Usuario";
export const LOAD_USUARIO_SUCCESS = "[UsuarioV2] Load Usuario Success";
export const LOAD_USUARIO_FAIL = "[UsuarioV2] Load Usuario Fail";
export const INSERT_USUARIO = "[UsuarioV2] Insert Usuario";
export const INSERT_USUARIO_SUCCESS = "[UsuarioV2] Insert Usuario Success";
export const INSERT_USUARIO_FAIL = "[UsuarioV2] Insert Usuario Fail";
export const UPDATE_USUARIO = "[UsuarioV2] Update Usuario";
export const UPDATE_USUARIO_SUCCESS = "[UsuarioV2] Update Usuario Success";
export const UPDATE_USUARIO_FAIL = "[UsuarioV2] Update Usuario Fail";
export const UPDATE_USUARIO_RELACIONES = "[UsuarioV2] Update Usuario relaciones";
export const UPDATE_USUARIO_RELACIONES_SUCCESS = "[UsuarioV2] Update Usuario relaciones Success";
export const UPDATE_USUARIO_RELACIONES_FAIL = "[UsuarioV2] Update Usuario relaciones Fail";
export const DELETE_USUARIO = "[UsuarioV2] Delete Usuario";
export const DELETE_USUARIO_SUCCESS = "[UsuarioV2] Delete Usuario Success";
export const DELETE_USUARIO_FAIL = "[UsuarioV2] Delete Usuario Fail";
export const SET_FORM_READ_ONLY = "[UsuarioV2] Set form read only";

export const createUsuario = createAction(CREATE_USUARIO);
export const loadUsuario = createAction(LOAD_USUARIO, props<{ id: number }>());
export const loadUsuarioSuccess = createAction(LOAD_USUARIO_SUCCESS, props<{ usuario: Usuario }>());
export const loadUsuarioFail = createAction(LOAD_USUARIO_FAIL, props<{ error: any }>());
export const insertUsuario = createAction(INSERT_USUARIO, props<{ usuario: Usuario }>());
export const insertUsuarioSuccess = createAction(INSERT_USUARIO_SUCCESS, props<{ usuario: Usuario }>());
export const insertUsuarioFail = createAction(INSERT_USUARIO_FAIL, props<{ error: any }>());
export const updateUsuario = createAction(UPDATE_USUARIO, props<{ usuario: Usuario }>());
export const updateUsuarioSuccess = createAction(UPDATE_USUARIO_SUCCESS, props<{ usuario: Usuario }>());
export const updateUsuarioFail = createAction(UPDATE_USUARIO_FAIL, props<{ error: any }>());
export const deleteUsuario = createAction(DELETE_USUARIO, props<{ id: number }>());
export const deleteUsuarioSuccess = createAction(DELETE_USUARIO_SUCCESS);
export const deleteUsuarioFail = createAction(DELETE_USUARIO_FAIL, props<{ error: any }>());
export const setFormReadOnly = createAction(SET_FORM_READ_ONLY, props<{ readonly: boolean }>());

export function getUsuarioFormActionCreateFactory(type: fromModels.GENERIC_TYPE, payload?: any): any {
  switch (type) {
    case fromModels.GENERIC_TYPE.INSERT_ITEM:
      return insertUsuario({ usuario: payload });
    case fromModels.GENERIC_TYPE.UPDATE_ITEM:
      return updateUsuario({ usuario: payload });
    case fromModels.GENERIC_TYPE.DELETE_ITEM:
      return deleteUsuario({ id: payload });
  }
}
