import { createSelector } from "@ngrx/store";

import * as fromFeature from "../reducers";
import * as fromUsuarioForm from "../reducers/usuario-form.reducer";

export const getUsuarioFormState = createSelector(
  fromFeature.getUsuarioV2State,
  (state: fromFeature.UsuarioV2State) => state.usuarioV2Form
);

export const getUsuario = createSelector(getUsuarioFormState, fromUsuarioForm.getItem);

export const getFormStatus = createSelector(getUsuarioFormState, fromUsuarioForm.getStatus);

export const getFormToolbar = createSelector(getUsuarioFormState, fromUsuarioForm.getToolbar);

export const getFormReadOnly = createSelector(getUsuarioFormState, fromUsuarioForm.getReadOnly);

export const getFormCurentTab = createSelector(getUsuarioFormState, fromUsuarioForm.getCurrentTab);

export const getFormType = createSelector(getUsuarioFormState, fromUsuarioForm.getFormType);

export const getFormLoaded = createSelector(getUsuarioFormState, fromUsuarioForm.getLoaded);

export const getFormUpdated = createSelector(getUsuarioFormState, fromUsuarioForm.getUpdated);
