import { createSelector } from "@ngrx/store";

import * as fromFeature from "../reducers";
import * as fromUsuarioList from "../reducers/usuario-list.reducer";

// selector para el estado general de la pantalla UsuarioList
export const getUsuarioListState = createSelector(
  fromFeature.getUsuarioV2State,
  (state: fromFeature.UsuarioV2State) => state.usuarioV2List
);

// selector para recuperar del estado general de UsuarioList, la lista de usuarios almacenados
export const getListaUsuarios = createSelector(getUsuarioListState, fromUsuarioList.getItems);

export const getFilter = createSelector(getUsuarioListState, fromUsuarioList.getFilter);

export const getStatus = createSelector(getUsuarioListState, fromUsuarioList.getStatus);

export const getTotalUsuarios = createSelector(getUsuarioListState, fromUsuarioList.getTotalItems);

export const getToolbar = createSelector(getUsuarioListState, fromUsuarioList.getToolbar);
