import { ModuleWithProviders } from "@angular/core";
import { RouterModule } from "@angular/router";
import { CanDeactivateGuard } from "../../shared/guard/candeactivate.guard";
import { UsuarioListV3Component, UsuarioFormV3Component, UsuarioFormUploadV3Component } from "./components";
import { UsuarioFormResolver } from "./services";

export const crudV3routing: ModuleWithProviders<RouterModule> = RouterModule.forChild([
  {
    path: "",
    component: UsuarioListV3Component
  },
  {
    path: "form",
    component: UsuarioFormV3Component,
    canDeactivate: [CanDeactivateGuard]
  },
  {
    path: "form/:id",
    component: UsuarioFormV3Component,
    canDeactivate: [CanDeactivateGuard],
    resolve: { usuario: UsuarioFormResolver }
  },
  {
    path: "form-upload",
    component: UsuarioFormUploadV3Component,
    canDeactivate: [CanDeactivateGuard]
  },
  {
    path: "form-upload/:id",
    component: UsuarioFormUploadV3Component,
    canDeactivate: [CanDeactivateGuard],
    resolve: { usuario: UsuarioFormResolver }
  }
]);
