import { Injectable } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { HttpUrlGenerator, EntityHttpResourceUrls } from "@ngrx/data";
import { Observable } from "rxjs";

import { UsuarioEnlace } from "../shared/usuario-enlace";
import { HttpUtilsService } from "../../../shared";
import { BaseDefaultDataService } from "../../../base/shared/base-default-data-service";

@Injectable()
export class UsuarioEnlacesDataService extends BaseDefaultDataService<UsuarioEnlace> {
  private httpUtilsService: HttpUtilsService;

  constructor(http: HttpClient, httpUrlGenerator: HttpUrlGenerator, httpUtilsService: HttpUtilsService) {
    let entityHttpResourceUrls: EntityHttpResourceUrls = {
      UsuarioEnlaces: {
        entityResourceUrl: "api/v1/usuario/enlaces/",
        collectionResourceUrl: "api/v1/usuario/enlaces/"
      }
    };
    httpUrlGenerator.registerHttpResourceUrls(entityHttpResourceUrls);
    super("UsuarioEnlaces", http, httpUrlGenerator);
    this.httpUtilsService = httpUtilsService;
  }

  /** Borra las entidades del servidor */
  deleteEntities(items: number[]): Observable<any> {
    return this.httpUtilsService.getHttpPost("usuario/enlaces/delete", items);
  }
}
