import { Injectable } from "@angular/core";
import { Resolve, ActivatedRouteSnapshot } from "@angular/router";
import { Observable } from "rxjs";

import { UsuarioEntityService } from "./usuario-entity.service";
import { filter, first, timeout } from "rxjs/operators";
import { Usuario } from "../../../common";

@Injectable()
export class UsuarioFormResolver implements Resolve<Usuario> {
  constructor(private usuarioService: UsuarioEntityService) {}

  /**Resolvemos el usuario a cargar como paso previo a activar el formulario */
  resolve(route: ActivatedRouteSnapshot): Observable<Usuario> {
    let usuarioId: number = +route.params.id;
    console.log(`recuperando el usuarioId ${usuarioId} desde UsuarioFormResolver`);

    return this.usuarioService.getByKey(usuarioId).pipe(
      filter(usuario => usuario && usuario.id == usuarioId),
      first(),
      timeout(3000)
    );
  }
}
