import { Item } from "../../../shared";
import { reject } from "../../../base/shared/utils";

export class UsuarioEnlace extends Item {
  constructor(
    public id: number,
    public orden: number,
    public url: string,
    public descripcion: string,
    public usuarioId: number
  ) {
    super(id);
  }

  public static newObject(): UsuarioEnlace {
    return new UsuarioEnlace(null, null, null, null, null);
  }

  public static copyFromObject(obj: UsuarioEnlace): UsuarioEnlace {
    return new UsuarioEnlace(obj.id, obj.orden, obj.url, obj.descripcion, obj.usuarioId);
  }

  /** Indicamos que valores del objeto UsuarioEnlace vamos a mapear en el formGroup */
  public static formValues(obj: UsuarioEnlace) {
    return reject(obj, ["id", "usuarioId"]);
  }
}

export function compareUsuarioEnlace(u1: UsuarioEnlace, u2: UsuarioEnlace) {
  if (u1.orden > u2.orden) {
    return 1;
  } else if (u1.orden < u2.orden) {
    return -1;
  } else return 0;
}
